aboutsummaryrefslogtreecommitdiff
path: root/dyndns.sh
diff options
context:
space:
mode:
authortoni <matzeton@googlemail.com>2013-04-15 15:04:30 +0200
committertoni <matzeton@googlemail.com>2013-04-15 15:04:30 +0200
commite33b5930923a439f4c73b6dd64253578c4131420 (patch)
treef3d9d1c359603174bb75fb2394ddb33a315dcd88 /dyndns.sh
initial commit
Diffstat (limited to 'dyndns.sh')
-rw-r--r--dyndns.sh53
1 files changed, 53 insertions, 0 deletions
diff --git a/dyndns.sh b/dyndns.sh
new file mode 100644
index 0000000..0221a5d
--- /dev/null
+++ b/dyndns.sh
@@ -0,0 +1,53 @@
+#!/bin/sh
+#
+# dyndns.org updater script
+#
+
+# dyndns options
+# Do not edit this file!
+# Use the default /etc/dyndns.conf file instead.
+USER=
+PASS=
+DOMAIN=
+WGET_ARGS="--no-check-certificate -q"
+CONF="/etc/dyndns.conf"
+TMPDIR="/tmp"
+
+if [ -x /usr/bin/wget -a -x /bin/wget ]; then
+ echo "$0: no wget found, abort .."
+fi
+
+# check for compiled in SSL support
+/usr/bin/wget --version | grep -E '\+https(.*)\+openssl' >&2 >/dev/null
+if [ $? -ne 0 ]; then
+ echo "$0: need wget with SSL support"
+ echo "$0: check wget --version"
+ exit 127
+fi
+
+[ -z "$1" ] || CONF="$1"
+if [ -r $CONF ]; then
+ . $CONF
+else
+ echo "$0: no $CONF, abort .."
+ exit 1
+fi
+
+[ -z "$2" ] || TMPDIR="$2"
+wget $WGET_ARGS "http://checkip.dyndns.com/index.html" --output-document="$TMPDIR/new.ip"
+[ -f "$TMPDIR/old.ip" ] || touch "$TMPDIR/old.ip"
+
+if [ "`cat $TMPDIR/new.ip`" = "`cat $TMPDIR/old.ip`" ]; then
+ echo "No new IP"
+else
+ wget $WGET_ARGS "https://$USER:$PASS@members.dyndns.org/nic/update?hostname=$DOMAIN" --output-document="$TMPDIR/upd.ip"
+ echo "New IP"
+ cat "$TMPDIR/upd.ip"
+ rm -f "$TMPDIR/upd.ip"
+ echo
+fi
+
+rm -f "$TMPDIR/old.ip"
+mv -f "$TMPDIR/new.ip" "$TMPDIR/old.ip"
+
+exit 0